<template>
	<div class="mb-8">
		<label :class="labelClass" class="mb-2 text-xs font-bold">{{ label }}</label>
		<div class="relative">
			<input
				class="w-full text-black py-2.5 text-sm px-4 h-10 box-border rounded-lg focus:outline-none"
				:class="[
					type === 'password' && !showPassword && value !== ''
						? 'text-3xl'
						: '',
						inputClass
				]"
				:name="name"
				:type="[showPassword ? 'text' : type]"
				:required="required"
				:value="value"
                :placeholder="placeholder"
				@input="inputHandler"
                @keydown.space="preventSpace"
			/>
			<div
				v-if="type === 'password'"
				class="absolute right-4 top-2"
				@click="show"
			>
				<img v-if="showPassword" src="../../assets/ic_eye_hide.svg" />
				<img v-else src="../../assets/ic_eye_hide_show.svg" />
			</div>
		</div>
	</div>
</template>

<script>
export default {
	data() {
		return {
			showPassword: false,
		};
	},
	props: {
		type: String,
		required: Boolean,
		value: String,
		label: String,
		name: String,
        placeholder: String,
		labelClass: String,
		inputClass: String
	},
	emits: ["update:value"],
	methods: {
		inputHandler(e) {
			this.$emit("update:value", e.target.value);
		},
		show() {
			this.showPassword = !this.showPassword;
		},
        preventSpace(e) {
            if (this.name === 'username') {
                e.preventDefault();
            }
        }
	},
};
</script>

<style>
</style>